Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 2696)
@@ -298,4 +302,1174 @@
     USE vertical_nesting_mod,                                                  &
         ONLY:  vnested, vnest_init_grid
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i             !< index variable along x 
+    INTEGER(iwp) ::  j             !< index variable along y
+    INTEGER(iwp) ::  k             !< index variable along z
+    INTEGER(iwp) ::  k_top         !< topography top index on local PE
+    INTEGER(iwp) ::  l             !< loop variable 
+    INTEGER(iwp) ::  nzb_local_max !< vertical grid index of maximum topography height
+    INTEGER(iwp) ::  nzb_local_min !< vertical grid index of minimum topography height
+                                      
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_local      !< index for topography top at cell-center
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_tmp        !< dummy to calculate topography indices on u- and v-grid
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  topo !< input array for 3D topography and dummy array for setting "outer"-flags
+
+    REAL(wp) ::  dz_stretched  !< stretched vertical grid spacing
+
+
+!
+!-- Calculation of horizontal array bounds including ghost layers
+    nxlg = nxl - nbgp
+    nxrg = nxr + nbgp
+    nysg = nys - nbgp
+    nyng = nyn + nbgp
+
+!
+!-- Allocate grid arrays
+    ALLOCATE( ddzu(1:nzt+1), ddzw(1:nzt+1), dd2zu(1:nzt), dzu(1:nzt+1),        &
+              dzw(1:nzt+1), zu(nzb:nzt+1), zw(nzb:nzt+1) )
+
+!
+!-- Compute height of u-levels from constant grid length and dz stretch factors
+    IF ( dz == -1.0_wp )  THEN
+       message_string = 'missing dz'
+       CALL message( 'init_grid', 'PA0200', 1, 2, 0, 6, 0 ) 
+    ELSEIF ( dz <= 0.0_wp )  THEN
+       WRITE( message_string, * ) 'dz=',dz,' <= 0.0'
+       CALL message( 'init_grid', 'PA0201', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
+!-- Define the vertical grid levels
+    IF ( .NOT. ocean )  THEN
+!
+!--    Grid for atmosphere with surface at z=0 (k=0, w-grid).
+!--    The second u-level (k=1) corresponds to the top of the 
+!--    Prandtl-layer.
+
+       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2 ) THEN
+          zu(0) = 0.0_wp
+      !    zu(0) = - dz * 0.5_wp
+       ELSE
+          zu(0) = - dz * 0.5_wp
+       ENDIF
+       zu(1) =   dz * 0.5_wp
+
+       dz_stretch_level_index = nzt+1
+       dz_stretched = dz
+       DO  k = 2, nzt+1
+          IF ( dz_stretch_level <= zu(k-1)  .AND.  dz_stretched < dz_max )  THEN
+             dz_stretched = dz_stretched * dz_stretch_factor
+             dz_stretched = MIN( dz_stretched, dz_max )
+             IF ( dz_stretch_level_index == nzt+1 ) dz_stretch_level_index = k-1
+          ENDIF
+          zu(k) = zu(k-1) + dz_stretched
+       ENDDO
+
+!
+!--    Compute the w-levels. They are always staggered half-way between the 
+!--    corresponding u-levels. In case of dirichlet bc for u and v at the 
+!--    ground the first u- and w-level (k=0) are defined at same height (z=0). 
+!--    The top w-level is extrapolated linearly.
+       zw(0) = 0.0_wp
+       DO  k = 1, nzt
+          zw(k) = ( zu(k) + zu(k+1) ) * 0.5_wp
+       ENDDO
+       zw(nzt+1) = zw(nzt) + 2.0_wp * ( zu(nzt+1) - zw(nzt) )
+
+    ELSE
+!
+!--    Grid for ocean with free water surface is at k=nzt (w-grid).
+!--    In case of neumann bc at the ground the first first u-level (k=0) lies
+!--    below the first w-level (k=0). In case of dirichlet bc the first u- and
+!--    w-level are defined at same height, but staggered from the second level.
+!--    The second u-level (k=1) corresponds to the top of the Prandtl-layer.
+       zu(nzt+1) =   dz * 0.5_wp
+       zu(nzt)   = - dz * 0.5_wp
+
+       dz_stretch_level_index = 0
+       dz_stretched = dz
+       DO  k = nzt-1, 0, -1
+!
+!--       The default value of dz_stretch_level is positive, thus the first 
+!--       condition is always true. Hence, the second condition is necessary.
+          IF ( dz_stretch_level >= zu(k+1)  .AND.  dz_stretch_level <= 0.0  &
+               .AND.  dz_stretched < dz_max )  THEN
+             dz_stretched = dz_stretched * dz_stretch_factor
+             dz_stretched = MIN( dz_stretched, dz_max )
+             IF ( dz_stretch_level_index == 0 ) dz_stretch_level_index = k+1
+          ENDIF
+          zu(k) = zu(k+1) - dz_stretched
+       ENDDO
+
+!
+!--    Compute the w-levels. They are always staggered half-way between the 
+!--    corresponding u-levels, except in case of dirichlet bc for u and v
+!--    at the ground. In this case the first u- and w-level are defined at 
+!--    same height. The top w-level (nzt+1) is not used but set for 
+!--    consistency, since w and all scalar variables are defined up tp nzt+1.
+       zw(nzt+1) = dz
+       zw(nzt)   = 0.0_wp
+       DO  k = 0, nzt
+          zw(k) = ( zu(k) + zu(k+1) ) * 0.5_wp
+       ENDDO
+
+!
+!--    In case of dirichlet bc for u and v the first u- and w-level are defined
+!--    at same height.
+       IF ( ibc_uv_b == 0 ) THEN
+          zu(0) = zw(0)
+       ENDIF
+
+    ENDIF
+
+!
+!-- Compute grid lengths.
+    DO  k = 1, nzt+1
+       dzu(k)  = zu(k) - zu(k-1)
+       ddzu(k) = 1.0_wp / dzu(k)
+       dzw(k)  = zw(k) - zw(k-1)
+       ddzw(k) = 1.0_wp / dzw(k)
+    ENDDO
+
+    DO  k = 1, nzt
+       dd2zu(k) = 1.0_wp / ( dzu(k) + dzu(k+1) )
+    ENDDO
+    
+!    
+!-- The FFT- SOR-pressure solvers assume grid spacings of a staggered grid
+!-- everywhere. For the actual grid, the grid spacing at the lowest level
+!-- is only dz/2, but should be dz. Therefore, an additional array
+!-- containing with appropriate grid information is created for these
+!-- solvers.
+    IF ( psolver(1:9) /= 'multigrid' )  THEN
+       ALLOCATE( ddzu_pres(1:nzt+1) )
+       ddzu_pres = ddzu
+       ddzu_pres(1) = ddzu_pres(2)  ! change for lowest level
+    ENDIF
+
+!
+!-- Compute the reciprocal values of the horizontal grid lengths.
+    ddx = 1.0_wp / dx
+    ddy = 1.0_wp / dy
+    dx2 = dx * dx
+    dy2 = dy * dy
+    ddx2 = 1.0_wp / dx2
+    ddy2 = 1.0_wp / dy2
+
+!
+!-- Allocate 3D array to set topography
+    ALLOCATE( topo(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    topo = 0
+!
+!-- Initialize topography by generic topography or read from topography from file.  
+    CALL init_topo( topo )
+!
+!-- Set flags to mask topography on the grid. 
+    CALL set_topo_flags( topo )    
+!
+!-- Calculate wall flag arrays for the multigrid method.
+!-- Please note, wall flags are only applied in the non-optimized version.
+    IF ( psolver == 'multigrid_noopt' )  CALL poismg_noopt_init 
+
+!
+!-- Init flags for ws-scheme to degrade order of the numerics near walls, i.e. 
+!-- to decrease the numerical stencil appropriately.
+    IF ( momentum_advec == 'ws-scheme'  .OR.  scalar_advec == 'ws-scheme' )    &
+       CALL ws_init_flags
+
+!
+!-- Calculated grid-dependent as well as near-wall mixing length 
+    CALL init_mixing_length
+
+!
+!-- Determine the maximum level of topography. It is used for
+!-- steering the degradation of order of the applied advection scheme, 
+!-- as well in the lpm. 
+!-- In case of non-cyclic lateral boundaries, the order of the advection
+!-- scheme has to be reduced up to nzt (required at the lateral boundaries).
+    k_top = 0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb, nzt + 1
+             k_top = MAX( k_top, MERGE( k, 0,                                  &
+                                        .NOT. BTEST( topo(k,j,i), 0 ) ) )
+          ENDDO
+       ENDDO
+    ENDDO
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( k_top + 1, nzb_max, 1, MPI_INTEGER,                    & !is +1 really necessary here?
+                        MPI_MAX, comm2d, ierr )
+#else
+    nzb_max = k_top + 1
+#endif
+    IF ( inflow_l  .OR.  outflow_l  .OR.  force_bound_l  .OR.  nest_bound_l  .OR.&
+         inflow_r  .OR.  outflow_r  .OR.  force_bound_r  .OR.  nest_bound_r  .OR.&
+         inflow_n  .OR.  outflow_n  .OR.  force_bound_n  .OR.  nest_bound_n  .OR.&
+         inflow_s  .OR.  outflow_s  .OR.  force_bound_s  .OR.  nest_bound_s )    &
+         nzb_max = nzt
+!   
+!-- Finally, if topography extents up to the model top, limit nzb_max to nzt.
+    nzb_max = MIN( nzb_max, nzt ) 
+
+!
+!-- Initialize boundary conditions via surface type
+    CALL init_bc
+
+!
+!-- Allocate and set topography height arrays required for data output
+    IF ( TRIM( topography ) /= 'flat' )  THEN
+!
+!--    Allocate and set the arrays containing the topography height
+       IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn),                             &
+                    zw_w_inner(nxl:nxr+1,nys:nyn) )
+       ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn+1),                             &
+                    zw_w_inner(nxl:nxr,nys:nyn+1) )
+       ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn+1),                           &
+                    zw_w_inner(nxl:nxr+1,nys:nyn+1) )
+       ELSE
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn),                               &
+                    zw_w_inner(nxl:nxr,nys:nyn) )
+       ENDIF
+
+       zu_s_inner   = 0.0_wp
+       zw_w_inner   = 0.0_wp
+!
+!--    Determine local topography height on scalar and w-grid. Note, setting
+!--    lateral boundary values is not necessary, realized via wall_flags_0 
+!--    array. Further, please note that loop bounds are different from 
+!--    nxl to nxr and nys to nyn on south and right model boundary, hence, 
+!--    use intrinsic lbound and ubound functions to infer array bounds.
+       DO  i = LBOUND(zu_s_inner, 1), UBOUND(zu_s_inner, 1)
+          DO  j = LBOUND(zu_s_inner, 2), UBOUND(zu_s_inner, 2)
+!
+!--          Topography height on scalar grid. Therefore, determine index of 
+!--          upward-facing surface element on scalar grid. 
+             zu_s_inner(i,j) = zu( get_topography_top_index( j, i, 's' ) )
+!
+!--          Topography height on w grid. Therefore, determine index of 
+!--          upward-facing surface element on w grid.
+             zw_w_inner(i,j) = zw( get_topography_top_index( j, i, 's' ) )
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- In the following, calculate 2D index arrays. Note, these will be removed
+!-- soon. 
+!-- Allocate outer and inner index arrays for topography and set
+!-- defaults.                    
+    ALLOCATE( nzb_s_inner(nysg:nyng,nxlg:nxrg),                                &
+              nzb_s_outer(nysg:nyng,nxlg:nxrg),                                &
+              nzb_u_inner(nysg:nyng,nxlg:nxrg),                                &
+              nzb_u_outer(nysg:nyng,nxlg:nxrg),                                &
+              nzb_v_inner(nysg:nyng,nxlg:nxrg),                                &
+              nzb_v_outer(nysg:nyng,nxlg:nxrg),                                &
+              nzb_w_inner(nysg:nyng,nxlg:nxrg),                                &
+              nzb_w_outer(nysg:nyng,nxlg:nxrg),                                &
+              nzb_diff_s_inner(nysg:nyng,nxlg:nxrg),                           &
+              nzb_diff_s_outer(nysg:nyng,nxlg:nxrg),                           &
+              nzb_local(nysg:nyng,nxlg:nxrg),                                  &
+              nzb_tmp(nysg:nyng,nxlg:nxrg) )
+!
+!-- Initialize 2D-index arrays. Note, these will be removed soon! 
+    nzb_local(nys:nyn,nxl:nxr) = get_topography_top_index( 's' )
+    CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
+
+    IF ( TRIM( topography ) /= 'flat' )  THEN
+#if defined( __parallel )
+       CALL MPI_ALLREDUCE( MAXVAL( get_topography_top_index( 's' ) ),          &
+                           nzb_local_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
+       CALL MPI_ALLREDUCE( MINVAL( get_topography_top_index( 's' ) ),          &
+                           nzb_local_min, 1, MPI_INTEGER, MPI_MIN, comm2d, ierr )                   
+#else
+       nzb_local_max = MAXVAL( get_topography_top_index( 's' ) )
+       nzb_local_min = MINVAL( get_topography_top_index( 's' ) )
+#endif
+!
+!--    Consistency checks
+       IF ( nzb_local_min < 0  .OR.  nzb_local_max  > nz + 1 )  THEN
+          WRITE( message_string, * ) 'nzb_local values are outside the',       &
+                                'model domain',                                &
+                                '&MINVAL( nzb_local ) = ', nzb_local_min,      &
+                                '&MAXVAL( nzb_local ) = ', nzb_local_max
+          CALL message( 'init_grid', 'PA0210', 1, 2, 0, 6, 0 )
+       ENDIF
+    ENDIF
+
+    nzb_s_inner = nzb;  nzb_s_outer = nzb
+    nzb_u_inner = nzb;  nzb_u_outer = nzb
+    nzb_v_inner = nzb;  nzb_v_outer = nzb
+    nzb_w_inner = nzb;  nzb_w_outer = nzb
+
+!
+!-- Define vertical gridpoint from (or to) which on the usual finite difference
+!-- form (which does not use surface fluxes) is applied 
+    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+       nzb_diff = nzb + 2
+    ELSE
+       nzb_diff = nzb + 1
+    ENDIF
+
+    nzb_diff_s_inner = nzb_diff;  nzb_diff_s_outer = nzb_diff
+!
+!-- Set Neumann conditions for topography. Will be removed soon.
+    IF ( .NOT. bc_ns_cyc )  THEN
+       IF ( nys == 0  )  THEN
+          nzb_local(-1,:)   = nzb_local(0,:)
+       ELSEIF ( nyn == ny )  THEN
+          nzb_local(ny+1,:) = nzb_local(ny,:)
+       ENDIF
+    ENDIF
+
+    IF ( .NOT. bc_lr_cyc )  THEN
+       IF ( nxl == 0  )  THEN
+          nzb_local(:,-1)   = nzb_local(:,0)
+          nzb_local(:,-2)   = nzb_local(:,0)
+          nzb_local(:,-3)   = nzb_local(:,0)
+       ELSEIF ( nxr == nx )  THEN
+          nzb_local(:,nx+1) = nzb_local(:,nx)
+          nzb_local(:,nx+2) = nzb_local(:,nx)          
+          nzb_local(:,nx+3) = nzb_local(:,nx)          
+       ENDIF          
+    ENDIF
+!
+!-- Initialization of 2D index arrays, will be removed soon!
+!-- Initialize nzb_s_inner and nzb_w_inner
+    nzb_s_inner = nzb_local
+    nzb_w_inner = nzb_local
+
+!
+!-- Initialize remaining index arrays:
+!-- first pre-initialize them with nzb_s_inner...
+    nzb_u_inner = nzb_s_inner
+    nzb_u_outer = nzb_s_inner
+    nzb_v_inner = nzb_s_inner
+    nzb_v_outer = nzb_s_inner
+    nzb_w_outer = nzb_s_inner
+    nzb_s_outer = nzb_s_inner
+
+!
+!-- nzb_s_outer: 
+!-- extend nzb_local east-/westwards first, then north-/southwards
+    nzb_tmp = nzb_local
+    DO  j = nys, nyn
+       DO  i = nxl, nxr
+          nzb_tmp(j,i) = MAX( nzb_local(j,i-1), nzb_local(j,i),             &
+                              nzb_local(j,i+1) )
+       ENDDO
+    ENDDO
+       
+    CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )
+     
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          nzb_s_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i),             &
+                                  nzb_tmp(j+1,i) )
+       ENDDO
+!
+!--    non-cyclic boundary conditions (overwritten by call of
+!--    exchange_horiz_2d_int below in case of cyclic boundary conditions)
+       IF ( nys == 0 )  THEN
+          j = -1
+          nzb_s_outer(j,i) = MAX( nzb_tmp(j+1,i), nzb_tmp(j,i) )
+       ENDIF
+       IF ( nyn == ny )  THEN
+          j = ny + 1
+          nzb_s_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i) )
+       ENDIF
+    ENDDO
+!
+!-- nzb_w_outer: 
+!-- identical to nzb_s_outer
+    nzb_w_outer = nzb_s_outer
+!
+!-- nzb_u_inner: 
+!-- extend nzb_local rightwards only
+    nzb_tmp = nzb_local
+    DO  j = nys, nyn
+       DO  i = nxl, nxr
+          nzb_tmp(j,i) = MAX( nzb_local(j,i-1), nzb_local(j,i) )
+       ENDDO
+    ENDDO
+       
+    CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )
+       
+    nzb_u_inner = nzb_tmp
+!
+!-- nzb_u_outer: 
+!-- extend current nzb_tmp (nzb_u_inner) north-/southwards
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          nzb_u_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i),             &
+                                  nzb_tmp(j+1,i) )
+       ENDDO
+!
+!--    non-cyclic boundary conditions (overwritten by call of
+!--    exchange_horiz_2d_int below in case of cyclic boundary conditions)
+       IF ( nys == 0 )  THEN
+          j = -1
+          nzb_u_outer(j,i) = MAX( nzb_tmp(j+1,i), nzb_tmp(j,i) )
+       ENDIF
+       IF ( nyn == ny )  THEN
+          j = ny + 1
+          nzb_u_outer(j,i) = MAX( nzb_tmp(j-1,i), nzb_tmp(j,i) )
+       ENDIF
+    ENDDO
+
+!
+!-- nzb_v_inner:
+!-- extend nzb_local northwards only
+    nzb_tmp = nzb_local
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          nzb_tmp(j,i) = MAX( nzb_local(j-1,i), nzb_local(j,i) )
+       ENDDO
+    ENDDO
+       
+    CALL exchange_horiz_2d_int( nzb_tmp, nys, nyn, nxl, nxr, nbgp )      
+    nzb_v_inner = nzb_tmp
+
+!
+!-- nzb_v_outer: 
+!-- extend current nzb_tmp (nzb_v_inner) right-/leftwards
+    DO  j = nys, nyn
+       DO  i = nxl, nxr
+          nzb_v_outer(j,i) = MAX( nzb_tmp(j,i-1), nzb_tmp(j,i),                &
+                                  nzb_tmp(j,i+1) )
+       ENDDO
+!
+!--    non-cyclic boundary conditions (overwritten by call of
+!--    exchange_horiz_2d_int below in case of cyclic boundary conditions)
+       IF ( nxl == 0 )  THEN
+          i = -1
+          nzb_v_outer(j,i) = MAX( nzb_tmp(j,i+1), nzb_tmp(j,i) )
+       ENDIF
+       IF ( nxr == nx )  THEN
+          i = nx + 1
+          nzb_v_outer(j,i) = MAX( nzb_tmp(j,i-1), nzb_tmp(j,i) )
+       ENDIF
+    ENDDO
+
+!
+!-- Exchange of lateral boundary values (parallel computers) and cyclic
+!-- boundary conditions, if applicable.
+!-- Since nzb_s_inner and nzb_w_inner are derived directly from nzb_local
+!-- they do not require exchange and are not included here.
+    CALL exchange_horiz_2d_int( nzb_u_inner, nys, nyn, nxl, nxr, nbgp )
+    CALL exchange_horiz_2d_int( nzb_u_outer, nys, nyn, nxl, nxr, nbgp )
+    CALL exchange_horiz_2d_int( nzb_v_inner, nys, nyn, nxl, nxr, nbgp )
+    CALL exchange_horiz_2d_int( nzb_v_outer, nys, nyn, nxl, nxr, nbgp )
+    CALL exchange_horiz_2d_int( nzb_w_outer, nys, nyn, nxl, nxr, nbgp )
+    CALL exchange_horiz_2d_int( nzb_s_outer, nys, nyn, nxl, nxr, nbgp )
+
+!
+!-- Set the individual index arrays which define the k index from which on
+!-- the usual finite difference form (which does not use surface fluxes) is
+!-- applied 
+    IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
+       nzb_diff_s_inner   = nzb_s_inner + 2
+       nzb_diff_s_outer   = nzb_s_outer + 2
+    ELSE
+       nzb_diff_s_inner   = nzb_s_inner + 1
+       nzb_diff_s_outer   = nzb_s_outer + 1
+    ENDIF
+!
+!-- Vertical nesting: communicate vertical grid level arrays between fine and
+!-- coarse grid
+    IF ( vnested )  CALL vnest_init_grid
+
+ END SUBROUTINE init_grid
+
+! Description:
+! -----------------------------------------------------------------------------!
+!> Set temporary topography flags and reference buildings on top of underlying
+!> orography. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE process_topography( topo_3d )
+
+    USE arrays_3d,                                                             &
+        ONLY:  zw
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, land_surface, ocean, urban_surface
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
+               nzt
+
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  buildings_f, building_id_f, input_pids_static,                  &
+               terrain_height_f
+
+    USE kinds
+
+    USE pegrid
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i         !< running index along x-direction
+    INTEGER(iwp) ::  j         !< running index along y-direction
+    INTEGER(iwp) ::  k         !< running index along z-direction with respect to numeric grid
+    INTEGER(iwp) ::  k2        !< running index along z-direction with respect to netcdf grid
+    INTEGER(iwp) ::  k_surf    !< orography top index, used to map 3D buildings onto terrain
+    INTEGER(iwp) ::  nr        !< index variable indication maximum terrain height for respective building ID
+    INTEGER(iwp) ::  num_build !< counter for number of buildings
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  displace_dum        !< displacements of start addresses, used for MPI_ALLGATHERV
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids           !< building IDs on entire model domain
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final     !< building IDs on entire model domain, multiple occurences are sorted out 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_final_tmp !< temporary array used for resizing
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_l         !< building IDs on local subdomain
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  build_ids_l_tmp     !< temporary array used to resize array of building IDs
+
+    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings     !< number of buildings with different ID on entire model domain
+    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  num_buildings_l   !< number of buildings with different ID on local subdomain
+
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d !< input array for 3D topography and dummy array for setting "outer"-flags
+
+    REAL(wp)                            ::  ocean_offset        !< offset to consider inverse vertical coordinate at topography definition
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  oro_max             !< maximum terrain height occupied by an building with certain id
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  oro_max_l           !< maximum terrain height occupied by an building with certain id, on local subdomain
+
+!
+!-- In the following, buildings and orography are further preprocessed 
+!-- before they are mapped on the LES grid.
+!-- Buildings are mapped on top of the orography by maintaining the roof 
+!-- shape of the building. This can be achieved by referencing building on 
+!-- top of the maximum terrain height within the area occupied by the 
+!-- respective building. As buildings and terrain height are defined PE-wise,
+!-- parallelization of this referencing is required (a building can be 
+!-- distributed between different PEs).  
+!-- In a first step, determine the number of buildings with different 
+!-- building id on each PE. In a next step, all building ids are gathered
+!-- into one array which is present to all PEs. For each building ID, 
+!-- the maximum terrain height occupied by the respective building is 
+!-- computed and distributed to each PE.  
+!-- Finally, for each building id and its respective reference orography, 
+!-- builidings are mapped on top.   
+!-- 
+!-- First, pre-set topography flags, bit 1 indicates orography, bit 2 
+!-- buildings 
+!-- classify the respective surfaces.
+    topo_3d          = IBSET( topo_3d, 0 )
+    topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
+!
+!-- Reference buildings on top of orography. This is not necessary
+!-- if topography is read from ASCII file as no distinction between buildings
+!-- and terrain height can be made. Moreover, this is also not necessary if
+!-- urban-surface and land-surface model are used at the same time. 
+    IF ( input_pids_static )  THEN 
+       num_buildings_l = 0
+       num_buildings   = 0
+!
+!--    Allocate at least one element for building ids, 
+       ALLOCATE( build_ids_l(1) )
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
+                IF ( num_buildings_l(myid) > 0 )  THEN
+                   IF ( ANY( building_id_f%var(j,i) .EQ.  build_ids_l ) )  THEN
+                      CYCLE
+                   ELSE
+                      num_buildings_l(myid) = num_buildings_l(myid) + 1
+!
+!--                   Resize array with different local building ids
+                      ALLOCATE( build_ids_l_tmp(1:SIZE(build_ids_l)) )
+                      build_ids_l_tmp = build_ids_l
+                      DEALLOCATE( build_ids_l )
+                      ALLOCATE( build_ids_l(1:num_buildings_l(myid)) )
+                      build_ids_l(1:num_buildings_l(myid)-1) =                 &
+                                  build_ids_l_tmp(1:num_buildings_l(myid)-1)
+                      build_ids_l(num_buildings_l(myid)) = building_id_f%var(j,i)
+                      DEALLOCATE( build_ids_l_tmp )
+                   ENDIF
+!
+!--             First occuring building id on PE 
+                ELSE 
+                   num_buildings_l(myid) = num_buildings_l(myid) + 1
+                   build_ids_l(1) = building_id_f%var(j,i)
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+!
+!--    Determine number of different building ids for the entire domain 
+#if defined( __parallel ) 
+       CALL MPI_ALLREDUCE( num_buildings_l, num_buildings, numprocs,              &
+                           MPI_INTEGER, MPI_SUM, comm2d, ierr ) 
+#else
+       num_buildings = num_buildings_l
+#endif
+!
+!--    Gather all buildings ids on each PEs. 
+!--    First, allocate array encompassing all building ids in model domain.  
+       ALLOCATE( build_ids(1:SUM(num_buildings)) )
+#if defined( __parallel ) 
+!
+!--    Allocate array for displacements. 
+!--    As each PE may has a different number of buildings, so that
+!--    the block sizes send by each PE may not be equal. Hence, 
+!--    information about the respective displacement is required, indicating 
+!--    the respective adress where each MPI-task writes into the receive 
+!--    buffer array  
+       ALLOCATE( displace_dum(0:numprocs-1) )
+       displace_dum(0) = 0
+       DO i = 1, numprocs-1
+          displace_dum(i) = displace_dum(i-1) + num_buildings(i-1)
+       ENDDO
+
+       CALL MPI_ALLGATHERV( build_ids_l(1:num_buildings_l(myid)),                 &
+                            num_buildings(myid),                                  &
+                            MPI_INTEGER,                                          &
+                            build_ids,                                            &
+                            num_buildings,                                        &
+                            displace_dum,                                         & 
+                            MPI_INTEGER,                                          &
+                            comm2d, ierr )   
+
+       DEALLOCATE( displace_dum )
+
+#else
+       build_ids = build_ids_l
+#endif
+
+!
+!--    Note, in parallel mode building ids can occure mutliple times, as 
+!--    each PE has send its own ids. Therefore, sort out building ids which 
+!--    appear more than one time. 
+       num_build = 0
+       DO  nr = 1, SIZE(build_ids)
+
+          IF ( ALLOCATED(build_ids_final) )  THEN
+             IF ( ANY( build_ids(nr) .EQ. build_ids_final ) )  THEN
+                CYCLE
+             ELSE
+                num_build = num_build + 1
+!
+!--             Resize
+                ALLOCATE( build_ids_final_tmp(1:num_build) )
+                build_ids_final_tmp(1:num_build-1) = build_ids_final(1:num_build-1)
+                DEALLOCATE( build_ids_final )
+                ALLOCATE( build_ids_final(1:num_build) )
+                build_ids_final(1:num_build-1) = build_ids_final_tmp(1:num_build-1)
+                build_ids_final(num_build) = build_ids(nr)
+                DEALLOCATE( build_ids_final_tmp )
+             ENDIF             
+          ELSE
+             num_build = num_build + 1
+             ALLOCATE( build_ids_final(1:num_build) )
+             build_ids_final(num_build) = build_ids(nr)
+          ENDIF
+       ENDDO
+
+!
+!--    Finally, determine maximumum terrain height occupied by the 
+!--    respective building. First, on each PE locally. 
+       ALLOCATE( oro_max_l(1:SIZE(build_ids_final)) )
+       ALLOCATE( oro_max(1:SIZE(build_ids_final))   )
+       oro_max_l = 0.0_wp
+
+       DO  nr = 1, SIZE(build_ids_final)
+          oro_max_l(nr) = MAXVAL(                                              &
+                           MERGE( terrain_height_f%var, 0.0_wp,                &
+                                  building_id_f%var(nys:nyn,nxl:nxr) .EQ.      &
+                                  build_ids_final(nr) ) )
+       ENDDO
+   
+#if defined( __parallel )    
+       IF ( SIZE(build_ids_final) >= 1 ) THEN
+          CALL MPI_ALLREDUCE( oro_max_l, oro_max, SIZE( oro_max ), MPI_REAL,   &
+                              MPI_MAX, comm2d, ierr ) 
+       ENDIF
+#else
+       oro_max = oro_max_l
+#endif
+!
+!--    Map orography as well as buildings on grid. 
+!--    In case of ocean simulations, add an offset.  
+       ocean_offset = MERGE( zw(0), 0.0_wp, ocean )
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb, nzt
+!
+!--             In a first step, if grid point is below or equal the given 
+!--             terrain height, grid point is flagged to be of type natural. 
+!--             Please note, in case there is also a building which is lower
+!--             than the vertical grid spacing, initialization of surface
+!--             attributes will not be correct as given surface information
+!--             will not be in accordance to the classified grid points. 
+!--             Hence, in this case, de-flag the grid point and give it 
+!--             urban type instead. 
+                IF ( zw(k) - ocean_offset <= terrain_height_f%var(j,i) )  THEN
+                    topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                    topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 ) 
+                ENDIF
+!
+!--             Set building grid points. Here, only consider 2D buildings. 
+!--             3D buildings require separate treatment. 
+                IF ( buildings_f%lod == 1 )  THEN
+                   IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
+!
+!--                   Determine index where maximum terrain height occupied by 
+!--                   the respective building height is stored.
+                      nr = MINLOC( ABS( build_ids_final -                      &
+                                        building_id_f%var(j,i) ), DIM = 1 )
+        
+                      IF ( zw(k) - ocean_offset <=                             &
+                           oro_max(nr) + buildings_f%var_2d(j,i) )  THEN
+                         topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                         topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
+!
+!--                      De-flag grid point of type natural. See comment above.
+                         topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 1 ) 
+                      ENDIF
+                   ENDIF
+                ENDIF
+             ENDDO
+!
+!--          Map 3D buildings onto terrain height.  
+             IF ( buildings_f%lod == 2 )  THEN
+                IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
+!
+!--                Determine topo index occupied by terrain
+                   k_surf = MAXLOC( MERGE( 1, 0,                               &
+                                           .NOT. BTEST( topo_3d(:,j,i), 0 ) ), &
+                                    DIM = 1 ) - 1
+                   k2 = nzb+1
+                   DO k = k_surf + 1, nzt + 1
+                      IF ( k2 <= buildings_f%nz )  THEN
+                         IF ( buildings_f%var_3d(k2,j,i) == 1 )  THEN
+                            topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                            topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
+                         ENDIF
+                      ENDIF
+                      k2 = k2 + 1
+                   ENDDO
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+!
+!--    Deallocate temporary arrays required for processing and reading data
+       IF ( ALLOCATED( oro_max         ) )  DEALLOCATE( oro_max         )
+       IF ( ALLOCATED( oro_max_l       ) )  DEALLOCATE( oro_max_l       )
+       IF ( ALLOCATED( build_ids_final ) )  DEALLOCATE( build_ids_final )
+!
+!-- Topography input via ASCII format. 
+    ELSE
+       ocean_offset     = MERGE( zw(0), 0.0_wp, ocean )
+       topo_3d          = IBSET( topo_3d, 0 )
+       topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb, nzt
+                IF ( zw(k) - ocean_offset <= buildings_f%var_2d(j,i) )  THEN
+                    topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                    topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 ) !indicates terrain
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+    CALL exchange_horiz_int( topo_3d, nys, nyn, nxl, nxr, nzt, nbgp )
+
+    IF ( .NOT. bc_ns_cyc )  THEN
+       IF ( nys == 0  )  topo_3d(:,-1,:)   = topo_3d(:,0,:)
+       IF ( nyn == ny )  topo_3d(:,ny+1,:) = topo_3d(:,ny,:)
+    ENDIF
+
+    IF ( .NOT. bc_lr_cyc )  THEN
+       IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
+       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)          
+    ENDIF
+
+ END SUBROUTINE process_topography
+
+
+! Description:
+! -----------------------------------------------------------------------------!
+!> Filter topography, i.e. fill holes resolved by only one grid point.  
+!> Such holes are suspected to lead to velocity blow-ups as continuity 
+!> equation on discrete grid cannot be fulfilled in such case.
+!------------------------------------------------------------------------------!
+ SUBROUTINE filter_topography( topo_3d )
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, message_string
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, nzt
+
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  building_id_f, building_type_f 
+
+    USE  pegrid
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i          !< running index along x-direction
+    INTEGER(iwp) ::  it         !< counter for number of iterations
+    INTEGER(iwp) ::  j          !< running index along y-direction
+    INTEGER(iwp) ::  k          !< running index along z-direction
+    INTEGER(iwp) ::  num_hole   !< number of holes (in topography) resolved by only one grid point 
+    INTEGER(iwp) ::  num_hole_l !< number of holes (in topography) resolved by only one grid point on local PE     
+    INTEGER(iwp) ::  num_wall   !< number of surrounding vertical walls for a single grid point
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  topo_tmp      !< temporary 3D-topography used to fill holes
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d       !< 3D-topography array merging buildings and orography
+!
+!-- Before checking for holes, set lateral boundary conditions for 
+!-- topography. After hole-filling, boundary conditions must be set again.
+!-- Several iterations are performed, in order to fill holes which might 
+!-- emerge by the filling-algorithm itself.
+    ALLOCATE( topo_tmp(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    topo_tmp = 0
+
+    num_hole = 99999
+    it = 0
+    DO WHILE ( num_hole > 0 )       
+
+       num_hole = 0    
+       CALL exchange_horiz_int( topo_3d, nys, nyn, nxl, nxr, nzt, nbgp )
+
+       topo_tmp = topo_3d
+!
+!--    In case of non-cyclic lateral boundaries, assume lateral boundary to be 
+!--    a solid wall. Thus, intermediate spaces of one grid point between 
+!--    boundary and some topographic structure will be filled.           
+       IF ( .NOT. bc_ns_cyc )  THEN
+          IF ( nys == 0  )  topo_tmp(:,-1,:)   = IBCLR( topo_tmp(:,0,:),  0 )
+          IF ( nyn == ny )  topo_tmp(:,ny+1,:) = IBCLR( topo_tmp(:,ny,:), 0 )
+       ENDIF
+
+       IF ( .NOT. bc_lr_cyc )  THEN
+          IF ( nxl == 0  )  topo_tmp(:,:,-1)   = IBCLR( topo_tmp(:,:,0),  0 )
+          IF ( nxr == nx )  topo_tmp(:,:,nx+1) = IBCLR( topo_tmp(:,:,nx), 0 )          
+       ENDIF
+
+       it = it + 1
+       num_hole_l = 0
+       DO i = nxl, nxr
+          DO j = nys, nyn
+             DO  k = nzb+1, nzt
+                IF ( BTEST( topo_tmp(k,j,i), 0 ) )  THEN
+                   num_wall = 0
+                   IF ( .NOT. BTEST( topo_tmp(k,j-1,i), 0 ) )                  &
+                      num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j+1,i), 0 ) )                  &
+                      num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j,i-1), 0 ) )                  &
+                      num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k,j,i+1), 0 ) )                  &
+                      num_wall = num_wall + 1
+                   IF ( .NOT. BTEST( topo_tmp(k-1,j,i), 0 ) )                  &
+                      num_wall = num_wall + 1   
+                   IF ( .NOT. BTEST( topo_tmp(k+1,j,i), 0 ) )                  &
+                      num_wall = num_wall + 1
+
+                   IF ( num_wall >= 4 )  THEN
+                      num_hole_l     = num_hole_l + 1
+!
+!--                   Clear flag 0 and set special flag ( bit 3) to indicate 
+!--                   that new topography point is a result of filtering process.
+                      topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                      topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 3 )
+!
+!--                   If filled grid point is occupied by a building, classify
+!--                   it as building grid point.
+                      IF ( building_type_f%from_file )  THEN
+                         IF ( building_type_f%var(j,i)   /=                    &  
+                              building_type_f%fill            .OR.             &       
+                              building_type_f%var(j+1,i) /=                    &  
+                              building_type_f%fill            .OR.             &                
+                              building_type_f%var(j-1,i) /=                    &                
+                              building_type_f%fill            .OR.             &                
+                              building_type_f%var(j,i+1) /=                    &                
+                              building_type_f%fill            .OR.             &                
+                              building_type_f%var(j,i-1) /=                    &                
+                              building_type_f%fill )  THEN
+!
+!--                         Set flag indicating building surfaces
+                            topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
+!
+!--                         Set building_type and ID at this position if not 
+!--                         already set. This is required for proper 
+!--                         initialization of urban-surface energy balance 
+!--                         solver.
+                            IF ( building_type_f%var(j,i) ==                   &
+                                 building_type_f%fill )  THEN
+
+                               IF ( building_type_f%var(j+1,i) /=              &
+                                    building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) =                   &
+                                                    building_type_f%var(j+1,i)
+                                  building_id_f%var(j,i) =                     &
+                                                    building_id_f%var(j+1,i)
+                               ELSEIF ( building_type_f%var(j-1,i) /=          &
+                                        building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) =                   &
+                                                    building_type_f%var(j-1,i)
+                                  building_id_f%var(j,i) =                     &
+                                                    building_id_f%var(j-1,i)
+                               ELSEIF ( building_type_f%var(j,i+1) /=          &
+                                        building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) =                   &
+                                                    building_type_f%var(j,i+1)
+                                  building_id_f%var(j,i) =                     &
+                                                    building_id_f%var(j,i+1)
+                               ELSEIF ( building_type_f%var(j,i-1) /=          &
+                                        building_type_f%fill )  THEN
+                                  building_type_f%var(j,i) =                   &
+                                                    building_type_f%var(j,i-1)
+                                  building_id_f%var(j,i) =                     &
+                                                    building_id_f%var(j,i-1)
+                               ENDIF
+                            ENDIF
+                         ENDIF
+                      ENDIF
+!
+!--                   If filled grid point is already classified as building
+!--                   everything is fine, else classify this grid point as
+!--                   natural type grid point. This case, values for the 
+!--                   surface type are already set.
+                      IF ( .NOT. BTEST( topo_3d(k,j,i), 2 ) )  THEN
+                         topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 )
+                      ENDIF
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+!
+!--    Count the total number of holes, required for informative message.
+#if defined( __parallel )
+       CALL MPI_ALLREDUCE( num_hole_l, num_hole, 1, MPI_INTEGER, MPI_SUM,      &
+                           comm2d, ierr )
+#else
+       num_hole = num_hole_l
+#endif    
+
+!
+!--    Create an informative message if any holes were filled.
+       IF ( num_hole > 0 )  THEN
+          WRITE( message_string, * ) num_hole, 'hole(s) resolved by only '//   &
+                                     'one grid point were filled at ', it,     &
+                                     'th iteration '
+          CALL message( 'init_grid', 'PA0430', 0, 0, 0, 6, 0 )
+       ENDIF
+
+
+    ENDDO
+
+    DEALLOCATE( topo_tmp )
+!
+!-- Finally, exchange topo_3d array again and if necessary set Neumann boundary
+!-- condition in case of non-cyclic lateral boundaries. 
+    CALL exchange_horiz_int( topo_3d, nys, nyn, nxl, nxr, nzt, nbgp )
+
+    IF ( .NOT. bc_ns_cyc )  THEN
+       IF ( nys == 0  )  topo_3d(:,-1,:)   = topo_3d(:,0,:)
+       IF ( nyn == ny )  topo_3d(:,ny+1,:) = topo_3d(:,ny,:)
+    ENDIF
+
+    IF ( .NOT. bc_lr_cyc )  THEN
+       IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
+       IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)          
+    ENDIF
+
+ END SUBROUTINE filter_topography
+
+! Description:
+! -----------------------------------------------------------------------------!
+!> Pre-computation of grid-dependent and near-wall mixing length.
+!> @todo: move subroutine to turbulence module developed by M1 (Tobi).
+!------------------------------------------------------------------------------!
+ SUBROUTINE init_mixing_length
+
+    USE arrays_3d,                                                             &
+        ONLY:  dzw, l_grid, l_wall, zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  message_string, wall_adjustment_factor
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,     &
+               wall_flags_0
+    
+    USE kinds
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i             !< index variable along x
+    INTEGER(iwp) ::  j             !< index variable along y
+    INTEGER(iwp) ::  k             !< index variable along z
+
+    ALLOCATE( l_grid(1:nzt) )
+    ALLOCATE( l_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!
+!-- Compute the grid-dependent mixing length.
+    DO  k = 1, nzt
+       l_grid(k)  = ( dx * dy * dzw(k) )**0.33333333333333_wp
+    ENDDO
+!
+!-- Initialize near-wall mixing length l_wall only in the vertical direction
+!-- for the moment, multiplication with wall_adjustment_factor further below
+    l_wall(nzb,:,:)   = l_grid(1)
+    DO  k = nzb+1, nzt
+       l_wall(k,:,:)  = l_grid(k)
+    ENDDO
+    l_wall(nzt+1,:,:) = l_grid(nzt)
+
+    DO  k = 1, nzt
+       IF ( l_grid(k) > 1.5_wp * dx * wall_adjustment_factor .OR.  &
+            l_grid(k) > 1.5_wp * dy * wall_adjustment_factor )  THEN
+          WRITE( message_string, * ) 'grid anisotropy exceeds ', &
+                                     'threshold given by only local', &
+                                     ' &horizontal reduction of near_wall ', &
+                                     'mixing length l_wall', &
+                                     ' &starting from height level k = ', k, '.'
+          CALL message( 'init_grid', 'PA0202', 0, 1, 0, 6, 0 )
+          EXIT
+       ENDIF
+    ENDDO
+!
+!-- In case of topography: limit near-wall mixing length l_wall further:
+!-- Go through all points of the subdomain one by one and look for the closest
+!-- surface.
+!-- Is this correct in the ocean case?
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+!
+!--          Check if current gridpoint belongs to the atmosphere
+             IF ( BTEST( wall_flags_0(k,j,i), 0 ) )  THEN
+!
+!--             Check for neighbouring grid-points.
+!--             Vertical distance, down
+                IF ( .NOT. BTEST( wall_flags_0(k-1,j,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_grid(k), zu(k) - zw(k-1) )
+!
+!--             Vertical distance, up
+                IF ( .NOT. BTEST( wall_flags_0(k+1,j,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_grid(k), zw(k) - zu(k) )
+!
+!--             y-distance
+                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 0 )  .OR.             &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dy )
+!
+!--             x-distance
+                IF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 0 )  .OR.             &
+                     .NOT. BTEST( wall_flags_0(k,j,i+1), 0 ) )                 &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dx )
+!
+!--              yz-distance (vertical edges, down)
+                 IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k-1,j+1,i), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dy**2 +                &
+                                       ( zu(k) - zw(k-1) )**2 ) )
+!
+!--              yz-distance (vertical edges, up)
+                 IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k+1,j+1,i), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dy**2 +                &
+                                       ( zw(k) - zu(k) )**2 ) )
+!   
+!--              xz-distance (vertical edges, down)
+                 IF ( .NOT. BTEST( wall_flags_0(k-1,j,i-1), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k-1,j,i+1), 0 )  )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dx**2 +                &
+                                       ( zu(k) - zw(k-1) )**2 ) )
+!
+!--              xz-distance (vertical edges, up)
+                 IF ( .NOT. BTEST( wall_flags_0(k+1,j,i-1), 0 )  .OR.          &
+                      .NOT. BTEST( wall_flags_0(k+1,j,i+1), 0 )  )             &
+                  l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * dx**2 +                &
+                                       ( zw(k) - zu(k) )**2 ) )
+!
+!--             xy-distance (horizontal edges)
+                IF ( .NOT. BTEST( wall_flags_0(k,j-1,i-1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i-1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j-1,i+1), 0 )  .OR.           &
+                     .NOT. BTEST( wall_flags_0(k,j+1,i+1), 0 ) )               &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 ) ) )
+!
+!--             xyz distance (vertical and horizontal edges, down)
+                IF ( .NOT. BTEST( wall_flags_0(k-1,j-1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j+1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j-1,i+1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k-1,j+1,i+1), 0 ) )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
+                                              +  ( zu(k) - zw(k-1) )**2  ) )
+!
+!--             xyz distance (vertical and horizontal edges, up)
+                IF ( .NOT. BTEST( wall_flags_0(k+1,j-1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j+1,i-1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j-1,i+1), 0 )  .OR.         &
+                     .NOT. BTEST( wall_flags_0(k+1,j+1,i+1), 0 ) )             &
+                   l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),              &
+                                        SQRT( 0.25_wp * ( dx**2 + dy**2 )      &
+                                              +  ( zw(k) - zu(k) )**2  ) )
+                  
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+!
+!-- Set lateral boundary conditions for l_wall
+    CALL exchange_horiz( l_wall, nbgp )     
+
+ END SUBROUTINE init_mixing_length
+
+! Description:
+! -----------------------------------------------------------------------------!
+!> Reads topography information from file or sets generic topography. Moreover, 
+!> all topography-relevant topography arrays are initialized, and grid flags
+!> are set.  
+!------------------------------------------------------------------------------!
+ SUBROUTINE init_topo( topo )
+
+    USE arrays_3d,                                                             &
+        ONLY:  zw
+        
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, building_height, building_length_x,       &
+               building_length_y, building_wall_left, building_wall_south,     &
+               canyon_height, canyon_wall_left, canyon_wall_south,             &
+               canyon_width_x, canyon_width_y, dp_level_ind_b, dz,             &
+               message_string, ocean, topography, topography_grid_convention,  &
+               tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y,   &
+               tunnel_wall_depth
+         
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+        
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
+               nzb, nzt
+    
+    USE kinds
+
+    USE pegrid
+
+    USE surface_mod,                                                           &
+        ONLY:  get_topography_top_index
 
     IMPLICIT NONE
